#!/bin/sh
# Script fuer das Bereitstellen der Telefonbucheintraege
# Datum: 21. Maerz 2006
# Programmer: IR Technik AG, Luzern, Manuel Raeber
# Input: Aktive Nummer (bei Anruf zu verwendendes Telefon), name des peroenlichen
#        Telefonbuches (Kommagetrennt). z. B. cm.cgi?SIP/200,userxy
# Achtung: asterisk und httpd muessen schreibrechte auf $datadir haben

# Definitionen
company='Your company'
datadir='/var/lib/asterisk/cm-data/'
booklist="${datadir}default.lst"
misslist="${datadir}missed_calls.tel"
sortbooklist="${datadir}sort_tmp.tel"
asthost='192.168.0.5'
cgidir='cgi-bin'
dialscript='call.pl'
addhtml='add.html'
delscript='rm_missed_call.cgi'
phonedelscript='rm_bookentry.cgi'
smssite='send_sms.html'

# Uebergebene Parameter in Variablen speichern
src_nmbr=`echo -e $1 | cut -d\, -f1`
bookname=`echo -e $1 | cut -d\, -f2`

sort $booklist > $sortbooklist

echo -e "Content-type: text/html\n\n"
echo "<html>"
echo "<head>"
echo "<meta http-equiv=\"Content-Type\" content=\"text/html; charset=iso-8859-15\">"
echo "<META HTTP-EQUIV=\"Refresh\" content=\"30; URL=http://${asthost}/${cgidir}/cm.cgi?$1\">"
echo "<meta http-equiv=\"Cache-Control: no-cache, must-revalidate\">"
echo "<meta http-equiv=\"expires\" content=\"0\">"
echo "</head>"
echo "<body style=\"color: rgb(255, 255, 255); background-color: rgb(0, 0, 0);\""
echo " link=\"#dddddd\" vlink=\"#dddddd\" alink=\"#dddddd\">"
echo "<form style=\"font-family: helvetica,arial,sans-serif;\""
echo " action=\"/${cgidir}/${dialscript}\" method=\"post\">"
echo "<input type=\"hidden\" name=\"src\" value=\"${src_nmbr}\">"
echo "<h2>${company} - Telefoninterface</h2>"
echo "Aktive Nummer: $src_nmbr"
echo "<br> Phonebook: $bookname"
echo "<table style=\"text-align: left; margin-left: 0px; margin-right: auto;\" border=\"1\">"
echo "<tbody>"
echo "<tr>"
echo "<td align=\"center\">Telefonnummer</td>"
echo "<td align=\"center\"><input size=\"30\" maxlength=\"30\" name=\"dest\"></td>"
echo "</tr>"
echo "</tbody>"
echo "</table>"
echo "<p><input value=\"Anrufen\" type=\"submit\"></p>"
echo "<span style=\"font-style: italic; font-size:75%\">"
echo "<br>"


# Missed call Liste anzeigen, wenn nicht leer

if [ -s $misslist ]
then 
  echo "<h3>Verpasste Anrufe</h3>"
  echo "<table border=\"0\" cellspacing=\"1\" cellpadding=\"1\" cols=\"1\" style=\"background-color: rgb(0, 0, 0);font-family:Verdana;font-size:11\">"
  echo "<tr>"
  echo "<td style=\"background-color: rgb(100, 100, 100);\"><b>Nummer</b></td>"
  echo "<td style=\"background-color: rgb(100, 100, 100);\"><b>Name</b></td>"
  echo "<td style=\"background-color: rgb(100, 100, 100);\"><b>Ruf zu</b></td>"
  echo "<td style=\"background-color: rgb(100, 100, 100);\"><b>Zeit</b></td>"
  echo "<td style=\"background-color: rgb(100, 100, 100);\"><b>Del</b></td>"

  echo "</tr>"
  while read zeile
    do
      callto=`echo $zeile | cut -d\; -f1`
      callfrom=`echo $zeile | cut -d\; -f2`
      callname=`echo $zeile | cut -d\; -f3`
      calltime=`echo $zeile | cut -d\; -f4`
      echo "<tr>"
      echo "<td nowrap style=\"background-color: rgb(100, 100, 100);\"><a href=\"http://$asthost/$cgidir/${dialscript}?dest=${callfrom}&src=${src_nmbr}\">${callfrom}</a></td>"
      echo "<td nowrap style=\"background-color: rgb(100, 100, 100);\">$callname</td>"
      echo "<td nowrap style=\"background-color: rgb(100, 100, 100);\">$callto</td>"
      echo "<td nowrap style=\"background-color: rgb(100, 100, 100);\">$calltime</td>"
      echo "<td nowrap style=\"background-color: rgb(100, 100, 100);\"><a href=\"http://$asthost/${cgidir}/${delscript}?${callfrom},${src_nmbr},${bookname}\">Del</a></td>"
      echo "</tr>"
    done < $misslist
  echo "</table>"
fi

echo "<table border=\"0\" cellspacing=\"10\" cellpadding=\"1\" cols=\"2\" style=\"background-color: rgb(0, 0, 0);\">"
echo "<td valign=\"top\">"

# Allgemeines Telefonbuch anzeigen

echo "<h3>Allgemeines Telefonbuch <a href=\"http://$asthost/${addhtml}?arg1=default&arg2=${src_nmbr}&arg3=${bookname}\">Add</a></h3>"
echo "<table border=\"0\" cellspacing=\"1\" cellpadding=\"1\" cols=\"5\" style=\"background-color: rgb(0, 0, 0);font-family:Verdana;font-size:11\">"
echo "<td style=\"background-color: rgb(100, 100, 100);\"><b>Name</b></td>"
echo "<td style=\"background-color: rgb(100, 100, 100);\"><b>Vorname</b></td>"
echo "<td style=\"background-color: rgb(100, 100, 100);\"><b>Zusatz</b></td>"
echo "<td style=\"background-color: rgb(100, 100, 100);\"><b>Nummer</b></td>"
echo "<td style=\"width:30px; background-color: rgb(100, 100, 100);\"><b>SMS</b></td>"
echo "<td style=\"width:30px; background-color: rgb(100, 100, 100);\"><b>Del</b></td>"
while read zeile
  do
    nachname=`echo $zeile | cut -d\; -f1`
    vorname=`echo $zeile | cut -d\; -f2`
    zusatz=`echo $zeile | cut -d\; -f3`
    nmbr=`echo $zeile | cut -d\; -f4`
    echo "<tr>"
    echo "<td nowrap style=\"background-color: rgb(100, 100, 100);\"><a href=\"http://$asthost/$cgidir/${dialscript}?dest=${nmbr}&src=${src_nmbr}\">${nachname}</a></td>"
    echo "<td nowrap style=\"background-color: rgb(100, 100, 100);\">$vorname</td>"
    echo "<td nowrap style=\"background-color: rgb(100, 100, 100);\">$zusatz</td>"
    echo "<td nowrap style=\"background-color: rgb(100, 100, 100);\">$nmbr</td>"
    echo "<td nowrap style=\"background-color: rgb(100, 100, 100);\"><a href=\"http://$asthost/${smssite}?arg1=${nmbr}&arg2=${src_nmbr}\">SMS</a></td>"
    echo "<td nowrap style=\"background-color: rgb(100, 100, 100);\"><a href=\"http://$asthost/${cgidir}/${phonedelscript}?${nmbr},${src_nmbr},${bookname}\">Del</a></td>"
    echo "</tr>"
  done < $sortbooklist
echo "</table>"
rm $sortbooklist

echo "</td>"
echo "<td valign=\"top\">"

# Wenn vorhanden, dann persoenliches Adressbuch anzeigen
if [ -f ${datadir}${bookname}.lst ]
then
  sort ${datadir}${bookname}.lst > $sortbooklist
  echo "<h3>Pers&ouml;nliches Telefonbuch (${bookname}) <a href=\"http://$asthost/${addhtml}?arg1=${bookname}&arg2=${src_nmbr}&arg3=${bookname}\">Add</a></h3>"
  echo "<table border=\"0\" cellspacing=\"1\" cellpadding=\"1\" cols=\"5\" style=\"background-color: rgb(0, 0, 0);font-family:Verdana;font-size:11\">"
  echo "<td style=\"background-color: rgb(100, 100, 100);\"><b>Name</b></td>"
  echo "<td style=\"background-color: rgb(100, 100, 100);\"><b>Vorname</b></td>"
  echo "<td style=\"background-color: rgb(100, 100, 100);\"><b>Zusatz</b></td>"
  echo "<td style=\"background-color: rgb(100, 100, 100);\"><b>Nummer</b></td>"
  echo "<td style=\"width:30px; background-color: rgb(100, 100, 100);\"><b>SMS</b></td>"
  echo "<td style=\"width:30px; background-color: rgb(100, 100, 100);\"><b>Del</b></td>"

  while read zeile
    do
      nachname=`echo $zeile | cut -d\; -f1`
      vorname=`echo $zeile | cut -d\; -f2`
      zusatz=`echo $zeile | cut -d\; -f3`
      nmbr=`echo $zeile | cut -d\; -f4`
      echo "<tr>"
      echo "<td nowrap style=\"background-color: rgb(100, 100, 100);\"><a href=\"http://$asthost/$cgidir/${dialscript}?dest=${nmbr}&src=${src_nmbr}\">${nachname}</a></td>"
      echo "<td nowrap style=\"background-color: rgb(100, 100, 100);\">$vorname</td>"
      echo "<td nowrap style=\"background-color: rgb(100, 100, 100);\">$zusatz</td>"
      echo "<td nowrap style=\"background-color: rgb(100, 100, 100);\">$nmbr</td>"
      echo "<td nowrap style=\"background-color: rgb(100, 100, 100);\"><a href=\"http://$asthost/${smssite}?arg1=${nmbr}&arg2=${src_nmbr}\">SMS</a></td>"
      echo "<td nowrap style=\"background-color: rgb(100, 100, 100);\"><a href=\"http://$asthost/${cgidir}/${phonedelscript}?${nmbr},${src_nmbr},${bookname}\">Del</a></td>"
      echo "</tr>"
    done < $sortbooklist
  echo "</table>"
  rm $sortbooklist
fi

echo "</td>"
echo "</table>"
echo "</span>"
echo "</body>"
echo "</html>"
